import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class SOR extends Frame
{  public SOR()
   {  setSize(800,300);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [] MultMV(double [][] A,double [] B, int N1,int N2)
   {  int i,j,k;
      double [] C = new double[N1];
      for(i=0;i<N1;i++)
      {  C[i]=0.0;
         for(k=0;k<N2;k++) C[i] += A[i][k] * B[k];
      }
      return C;
   }
   public int SORSimEq(double [][] A, double[] B, double [] X, int iterMax, int N, double Omega, double Eps)
   {
      double []Y = new double[N]; int i, j;
      for(i = 0; i < N; i++) X[i] = B[i] / A[i][i];
      double  E = Eps * 100; int R = 0;
      while( E > Eps && R < iterMax)
      {  R++; double dev = 0;
         for(i = 0; i < N; i++)
         {   Y[i] = B[i];
             for(j = 0; j < N; j++)
                 if(i != j) Y[i] -= A[i][j] * X[j];
             Y[i] /= A[i][i]; double EI = Y[i] - X[i];
             dev += EI * EI; X[i] += Omega * EI;
          }
          E = Math.sqrt(dev);
      }
      return R;
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN=10*Math.pow(10.0,(double)(N-1));
      return Math.rint(D*DN)/DN;
   }
   public void DrawData(Graphics g, int Y, double [][] A, double []B, int N)
   {  int i, j;
      for(i=0;i<N;i++)
      {
         for(j=0;j<N; j++)
         {  g.drawString( "" + round(A[i][j],3), 50 + j * 50,Y + i * 20);
         }
         g.drawString( "" + round(B[i],3), 350, Y + i * 20);
      }
      drawBra(g, 40, Y - 10, 50); drawKet(g,190, Y - 10, 50);
      drawBra(g,340, Y - 10, 50); drawKet(g,390, Y - 10, 50);
   } 

   public void DrawMatVect(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [] B,double [] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,205,Y+20);
      g.drawString( ope2,290,Y+20);
      for(i=0;i<N1;i++)
      { for(j=0;j<N2; j++)g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
        g.drawString( "" + round(B[i],3),235, Y + i*20);
        g.drawString( "" + round(C[i],3),350, Y + i*20);
      }  
      drawBra(g, 40, Y - 10, 50); drawKet(g,190, Y - 10, 50);
      drawBra(g,230, Y - 10, 50); drawKet(g,282, Y - 10, 50);
      drawBra(g,340, Y - 10, 50); drawKet(g,390, Y - 10, 50);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A={{3,1,1},{1,5,2},{1,2,5}};
      double []   B={10, 21, 30};
      double []   X={0,   0,  0};
      setTitle("SOR@");
      g.drawString( "f[^",20,50);
      DrawData(g, 80, A, B, 3);
      double Omega = 1.5;
      int R = SORSimEq(A, B, X, 1000, 3, Omega, 0.0001);
      g.drawString( "mF iJԂ񐔁@= " + R + " j",20,150);
      double []C= MultMV(A, X, 3, 3);
      DrawMatVect(g, "","", 180, A, X, C, 3,3);
   } 
   public static void main(String[] args)
   {  Frame w = new SOR();
      w.setVisible(true);
   }
}
